<?php
function bundle_clone_admin($form, &$form_state, $entity_type) {
  $entity_bundles = field_info_bundles($entity_type);
  $form['entity_type'] = array(
    '#type' => 'fieldset',
    '#title' => $entity_type,
    '#tree' => TRUE,
    '#prefix' => l('Back to entity select', 'admin/structure/bundle_clone'),
  );
  
  $form['entity_type']['type'] = array(
    '#type' => 'value',
    '#value' => $entity_type,
  );

  $form['entity_type']['bundles'] = array(
    '#type' => 'value',
    '#value' => $entity_bundles,
  );

  $form['entity_type'] += bundle_clone_entity_items($entity_bundles);

  $form['save'] = array(
    '#type' => 'submit',
    '#value' => t('Clone'),
  );
    
  return $form;
}

function bundle_clone_admin_validate(&$form, &$form_state) {
  bundle_clone_validate_selection($form, $form_state);
}

function bundle_clone_admin_submit(&$form, &$form_state) {
  $source = $form_state['values']['entity_type']['source'];
  $target = $form_state['values']['entity_type']['target'];
  $entity_type = $form_state['values']['entity_type']['type'];
  $bundles = $form_state['values']['entity_type']['bundles'];
  $holders = array(
    '!source' => l($bundles[$source]['label'], $bundles[$source]['admin']['real path']),
    '!target' => l($bundles[$target]['label'], $bundles[$target]['admin']['real path']),
  );
  drupal_set_message(t('Cloning !source into !target', $holders));
  bundle_clone_clone($entity_type, $source, $target);
}

function bundle_clone_clone($entity_type, $source, $target) {
  $instances = field_info_instances($entity_type, $source);
  $target_instances = field_info_instances($entity_type, $target);
  foreach ($instances as $instance => $config) {
    if (isset($target_instances[$instance])) {
      drupal_set_message(t('Skipping @instance', array('@instance' => $instance)));
      continue;
    }
    drupal_set_message(t('Creating @instance', array('@instance' => $instance)));

    unset($config['id']);
    $config['bundle'] = $target;
    field_create_instance($config);
  }
}

